//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
static void USMID() { void("%Z%%M%	%I%	%G% %U%"); }
static void RSCID() { void("$Id: HoldWindow.cc,v 1.4 1994/09/21 18:18:28 prb Exp $"); }
#include <Cvo/HoldWindow.h++>

static Cvo_Default defs[] = {
    "*CvoHoldWindow.Cursor: watch",
};

CONSTRUCTORS(Cvo_HoldWindow, Cvo_InputOnly, "CvoHoldWindow")
CVO_CREATE_REGISTER_FUNCTIONS(Cvo_HoldWindow)

void
Cvo_HoldWindow::_Init()
{   CVO_ENTER
    type = CvoT_HoldWindow;

    MakeOverlay(2);		// Confirm is on overlay 1
    ExpandFrame();
    Register(CvoMapRequestEvent, &Cvo_HoldWindow::MapEvent);
    Register(CvoUnmapRequestEvent, &Cvo_HoldWindow::UnMapEvent);
    CVO_VOID_RETURN
}

Cvo_HoldWindow::~Cvo_HoldWindow()
{
    UnMapEvent(0, 0);
}

void
Cvo_HoldWindow::MapEvent(XEvent *, void *)
{
    Cvo_Object *r = RootObject();

    if (!parent)
	return;


    r = r->focus;

    while (r && r != parent)
	r = r->Parent();
    if (r)
	TakeFocus();
    parent->holder = this;
}

void
Cvo_HoldWindow::UnMapEvent(XEvent *, void *)
{
    Cvo_Object *r = this;

    if (!parent)
	return;

    if (parent->holder == this)
	parent->holder = 0;
}
