//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
static void USMID() { void("%Z%%M%	%I%	%G% %U%"); }
static void RCSID() { void("$Id: I18N.cc,v 1.1 1995/06/04 07:17:45 prb Exp $"); }
#include <Cvo/Window.h++>

//
// WARNING:  This file contains characters with the 8th bit set.  DO NOT
// ALLOW YOUR EDITOR TO STRIP THEM OUT!
//
int ____load_18n_defaults = 1;

static Cvo_Default defs[] = {
    //
    // Standard default strings
    //
    "*about.label:		About",
    "*close.label:		Close",
    "*dismiss.label:		Dismiss",
    "*file.label:		File",
    "*help.label:		Help",
    "*new.label:		New",
    "*open.label:		Open",
    "*quit.label:		Exit",
    "*save.label:		Save",
    "*saveas.label:		Save As",
    "*version.label:		Version",

    "*CvoConfirm.cancel:	Cancel",
    "*CvoConfirm.confirm:	Confirm",
    "*CvoInform.dismiss:	Dismiss",

    "*CvoMenu.about.label:	_About...",
    "*CvoMenu.close.label:	_Close",
    "*CvoMenu.dismiss.label:	_Dimiss...",
    "*CvoMenu.file.label:	_File",
    "*CvoMenu.help.label:	_Help...",
    "*CvoMenu.new.label:	_New",
    "*CvoMenu.open.label:	_Open...",
    "*CvoMenu.quit.label:	E_xit...+<CTRL-Q>",
    "*CvoMenu.save.label:	_Save",
    "*CvoMenu.saveas.label:	Save _As...",
    "*CvoMenu.version.label:	_Version...",

    "*CvoMenuBar.file:		_File",
    "*CvoMenuBar.help:		_Help",

    "*CvoOpenFile.Title:	%C: Open File...",
    "*CvoSaveFile.Title:	%C: Save File As...",
    "*dir_label.label:		Directories:",
    "*dirfile_label.label:	Directory and File Name:",
    "*file_label.label:		Files:",
    "*filter_label.label:	File Filter:",
    "*noreadaccess.label:	No read access from this file.",
    "*nosuchfile.label:		No such file.",
    "*nowriteaccess.label:	No write access to this file.",
    "*reallyQuit.label:		Really Exit?",
    "*reallywrite.label:	Really replace file?",

#if	defined(I18N)
    //
    // Chinese default strings
    //
    "?.chinese*about.label:	",
    "?.chinese*version.label:	",
    "?.chinese*close.label:	",
    "?.chinese*dismiss.label:	ɢ",
    "?.chinese*file.label:	",
    "?.chinese*help.label:	",
    "?.chinese*new.label:	",
    "?.chinese*open.label:	",
    "?.chinese*quit.label:	뿪",
    "?.chinese*save.label:	",
    "?.chinese*saveas.label:	",

    "?.chinese*CvoConfirm.cancel:	ȡ",
    "?.chinese*CvoConfirm.confirm:	ȷ",

    "?.chinese*CvoInform.dismiss:	ɢ",

    "?.chinese*CvoMenu.about.label:	...(_A)",
    "?.chinese*CvoMenu.version.label:	...(_V)",
    "?.chinese*CvoMenu.close.label:	(_C)",
    "?.chinese*CvoMenu.dismiss.label:	ɢ...(_D)",
    "?.chinese*CvoMenu.file.label:	(_F)",
    "?.chinese*CvoMenu.help.label:	...(_H)",
    "?.chinese*CvoMenu.new.label:	(_N)",
    "?.chinese*CvoMenu.open.label:	...(_O)",
    "?.chinese*CvoMenu.quit.label:	뿪...(_X)+<CTRL-Q>",
    "?.chinese*CvoMenu.save.label:	(_S)",
    "?.chinese*CvoMenu.saveas.label:	...(_A)",

    "?.chinese*CvoMenuBar.file:		(_F)",
    "?.chinese*CvoMenuBar.help:		(_H)",

    "?.chinese*CvoOpenFile.Title:	%C: ļ...",
    "?.chinese*CvoSaveFile.Title:	%C: ļ...",
    "?.chinese*dir_label.label:	,eļ¼:",
    "?.chinese*dirfile_label.label:	ļ¼ļ:",
    "?.chinese*file_label.label:	ļ:",
    "?.chinese*filter_label.label:	ļ:",
    "?.chinese*noreadaccess.label:	ܶļ.",
    "?.chinese*nosuchfile.label:	ûļ.",
    "?.chinese*nowriteaccess.label:	дļ.",
    "?.chinese*reallyQuit.label:	뿪?",
    "?.chinese*reallywrite.label:	׼ļ>?",

    //
    // Japanese Default Strings
    //
    "?.ja_JP*about.label:		ġĤˤĤ",
    "?.ja_JP*version.label:		ġĤˤĤ",
    "?.ja_JP*close.label:		",
    "?.ja_JP*dismiss.label:		˴",
    "?.ja_JP*file.label:		ե",
    "?.ja_JP*help.label:		إ",
    "?.ja_JP*new.label:			",
    "?.ja_JP*open.label:		ץ",
    "?.ja_JP*quit.label:		λ",
    "?.ja_JP*save.label:		¸",
    "?.ja_JP*saveas.label:		¸",

    "?.ja_JP*CvoConfirm.cancel:		",
    "?.ja_JP*CvoConfirm.confirm:	ϣ",

    "?.ja_JP*CvoInform.dismiss:		˴",

    "?.ja_JP*CvoMenu.about.label:	ġĤˤĤ(_A)",
    "?.ja_JP*CvoMenu.version.label:	ġĤˤĤ(_V)",
    "?.ja_JP*CvoMenu.close.label:	(_C)",
    "?.ja_JP*CvoMenu.dismiss.label:	˴...(_D)",
    "?.ja_JP*CvoMenu.file.label:	ե(_F)",
    "?.ja_JP*CvoMenu.help.label:	إ...(_H)",
    "?.ja_JP*CvoMenu.new.label:		(_N)",
    "?.ja_JP*CvoMenu.open.label:	ץ...(_O)",
    "?.ja_JP*CvoMenu.quit.label:	λ...(_Q)+<CTRL-Q>",
    "?.ja_JP*CvoMenu.save.label:	¸(_S)",
    "?.ja_JP*CvoMenu.saveas.label:	¸...(_A)",

    "?.ja_JP*CvoMenuBar.file:		ե(_F)",
    "?.ja_JP*CvoMenuBar.help:		إ(_H)",

    "?.ja_JP*CvoOpenFile.Title:		%C: ...",
    "?.ja_JP*CvoSaveFile.Title:		%C: ̾¸...",
    "?.ja_JP*dir_label.label:		ǥ쥯ȥ:",
    "?.ja_JP*dirfile_label.label:	ǥ쥯ȥȥե̾:",
    "?.ja_JP*file_label.label:		ե:",
    "?.ja_JP*filter_label.label:	եե륿:",
// `ե' might be omitted.
//  "?.ja_JP*filter_label.label:	ե륿:",

    "?.ja_JP*noreadaccess.label:	Υեɤ߽Фޤ",
    "?.ja_JP*nosuchfile.label:	ե뤬ޤ",
    "?.ja_JP*nowriteaccess.label:	ΥեϽ񤭹ޤ",
    "?.ja_JP*reallyQuit.label:		˽λƤ⤤Ǥ",
//  "?.ja_JP*reallywrite.label:		֤Ƥ⤤Ǥ",
    "?.ja_JP*reallywrite.label:		˽񤭹Ǥ⤤Ǥ",
#endif

};
