//
// Copyright 1994, Cray Research, Inc.
//                 
// Permission to use, copy, modify and distribute this software and
// its accompanying documentation (the "Software") is granted without
// fee, provided that the above copyright notice and this permission
// notice appear in all copies of the Software and all supporting
// documentation, and the name of Cray Research, Inc. not be used in
// advertising or publicity pertaining to distribution of the 
// Software without the prior specific, written permission of Cray
// Research, Inc.  The Software is a proprietary product of Cray
// Research, Inc., and all rights not specifically granted by this
// license shall remain in Cray Research, Inc.  No charge may be made
// for the use or distribution of the Software.  The Software may be
// distributed as a part of a different product for which a fee is
// charged, if (i) that product contains or provides substantial
// functionality that is additional to, or different from, the
// functionality of the Software, and (ii) no separate, special or
// direct charge is made for the Software.
//         
// THE SOFTWARE IS MADE AVAILABLE "AS IS", AND ALL EXPRESS AND
// IMPLIED WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF FITNESS
// FOR A PARTICULAR PURPOSE, MERCHANTABILITY, AND FREEDOM FROM
// VIOLATION OF THIRD PARTY INTELLECTUAL PROPERTY RIGHTS, ARE HEREBY
// DISCLAIMED AND EXCLUDED BY CRAY RESEARCH, INC.  CRAY RESEARCH,
// INC. WILL NOT BE LIABLE IN ANY EVENT FOR ANY CONSEQUENTIAL,
// SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES ARISING OUT OF OR IN
// CONNECTION WITH THE PERFORMANCE OF THE SOFTWARE OR ITS USE BY ANY
// PERSON, OR ANY FAILURE OR NEGLIGENCE ON THE PART OF CRAY RESEARCH,
// INC., EXCEPT FOR THE GROSS NEGLIGENCE OR WILLFUL MISCONDUCT OF
// CRAY RESEARCH.
// 
// This License Agreement shall be governed by, and interpreted and
// construed in accordance with, the laws of the State of Minnesota,
// without reference to its provisions on the conflicts of laws, and
// excluding the United Nations Convention of the International Sale
// of Goods.
//
static void USMID() { void("%Z%%M%	%I%	%G% %U%"); }
static void RSCID() { void("$Id: Selection.cc,v 1.2 1994/08/10 17:54:53 prb Exp $"); }

#include <Cvo/Object.h++>

void
Cvo_Object::SelectorGone(XEvent *, void *)
{
    selectOwner = 0;
    selectRe = 0;
}

void
Cvo_Object::SetSelection(const Cvo_CharacterBuffer &cb)
{
    selectBuf = cb;

    if (selectOwner && selectOwner != this)
	selectOwner->SelectClear();

    if (selectOwner != this) {
	delete selectRe;
	selectOwner = this;
	selectRe = Register(CvoDestroyedEvent, &Cvo_Object::SelectorGone);
    }

    int loop = 10;

    Atom p = DisplayData()[CvoA_PRIMARY];

    do {
	XSetSelectionOwner(Dpy(), p, Win(), CurrentTime);
	if (XGetSelectionOwner(Dpy(), p) == Win())
	    break;
    } while (loop-- > 0);

    XChangeProperty(Dpy(), Root(),
		    DisplayData()[CvoA_SELECTION],
		    DisplayData()[CvoA_STRING],  8,
		    PropModeReplace,
		    (unsigned char *) selectBuf.mbValue(),
		    selectBuf.mbLength());
}

void
Cvo_Object::SelectClear(XEvent *, void *)
{
    if (selectOwner == this) {
	delete selectRe;
	selectRe = 0;
	selectOwner = 0;
    }
}

void
Cvo_Object::SelectRequest(XEvent *ev, void *)
{   CVO_ENTER

    XSelectionRequestEvent *xsre = (XSelectionRequestEvent *)ev;
    XSelectionEvent xse;

    xse.type = SelectionNotify;
    xse.display = xsre->display;
    xse.requestor = xsre->requestor;
    xse.selection = xsre->selection;
    xse.target = xsre->target;
    xse.property = xsre->property;
    xse.time = xsre->time;

    XSendEvent(xsre->display, xsre->requestor, False, 0, (XEvent *)&xse);
    CVO_VOID_RETURN
}
